# Highlight Changes

A Drupal 8 module to show changes made to a form as a visual diff. It supports
textareas, selects, checkboxes, radio buttons, and several other `input` types.
There is also support for fields controlled by CKEditor.

When a user select a new item in a list of checkboxes, the label will turn
green. Similarly when they deselect a checkbox, who started as checked, the
label will turn red.

A "Changes" link appears beneath edited text fields, which displays a visual
diff when clicked.

## Dependencies

This project uses the [diff](https://www.npmjs.com/package/diff) JavaScript
library to generate text diffs. This library must be installed into Drupal's 
`libraries` directory.

### Using [Yarn](https://yarnpkg.com/)

```
yarn install --modules-folder path/to/libraries
```

### Using [npm](https://www.npmjs.com/)

```
mkdir path/to/libraries/diff
npm v diff dist.tarball | xargs curl |
  tar xz --strip-components=1 -C path/to/libraries/diff
```

### Using Composer

If you are managing your Drupal install via composer, add the following block
to your project's composer.json.

```
  "repositories": [
    {
      "type": "package",
      "package": {
        "name": "kpdecker/diff",
        "version": "3.3.0",
        "type": "drupal-library",
        "dist": {
          "url": "https://registry.npmjs.org/diff/-/diff-3.3.0.tgz",
          "type": "tar"
        },
        "require": {
            "composer/installers": "^1.2.0"
        }
      }
    }
  ]
```

After adding the repository, require the module via composer.

```
composer require drupal/highlight_changes
```

## About

This module is developed by Rich Gerdes and Anton Sarukhanov for the [Rutgers
University Office of Information Technology](https://oit.rutgers.edu). For more
information, please contact the [OIT Webmasters]
(mailto:webmaster@oit.rutgers.edu).
